<template>
    <div class="relative mb-4 text-white">
        <button 
            class="flex items-baseline justify-between rounded-t py-1 px-2 w-48 transition-colors duration-150 ease-in-out content-center"
            :class="{
                'rounded-b':!open,
                'bg-teal-600 hover:bg-teal-700': !disabled && color == 'teal',
                'bg-purple-600 hover:bg-purple-700': !disabled && color == 'purple',
                'bg-red-600 hover:bg-red-700 text-black': !disabled && color == 'red',
                'bg-green-600 hover:bg-green-700': !disabled && color == 'green',
                'bg-purple-600 hover:bg-purple-700': !disabled && color == 'purple',
                'bg-blue-600 hover:bg-blue-700': !disabled && color == 'blue',
                'bg-green-600 hover:bg-green-700': !disabled && color == 'green',
                'bg-yellow-600 hover:bg-yellow-700 text-black': !disabled && color == 'yellow',
                'bg-gray-600 hover:bg-gray-700 text-gray-300': disabled,
            }"
            @click="openDropdown"
            @blur="open = false">
                <span class="overflow-hidden whitespace-no-wrap text-base">
                    <slot v-if="selectedId == -1"/>
                    <div v-else>                       <feather v-if="'feather' in selected" :type="selected.feather"         class="inline h-5 align-middle"  />
                        <fa-icon v-if="'fontawesome' in selected" :icon="selected.fontawesome" class="inline"  />
                        <img v-if="'image' in selected" :src="selected.image"                  class="inline h-5 align-middle"  />
                        {{ selected.label }}
                    </div>
                </span>
                <span>
                    <feather :class="{'-rotate-180':open,'rotate-0':!open}" class="transform transition-transform duration-700 ease-in-out bg-none justify-end align-middle h-5" type="chevron-down"/>
                </span>
        </button>
        <div 
            class="absolute z-10 w-48 bg-gray-300 rounded-b-lg transform transition-transform duration-700 ease-in-out origin-top text-black dropdown"
            :class="{'scale-y-0':!open,'scale-y-100':open}"
            @click="open = false">
            <a @click="select(index)" class="block py-1 px-2 cursor-pointer overflow-hidden hover:bg-grey-400" :class="{'rounded-b-lg':index == options.length-1}" v-for="(option,index) in options" :key="index">
                <feather v-if="'feather' in option" :type="option.feather"         class="inline w-4"  />
                <fa-icon v-if="'fontawesome' in option" :icon="option.fontawesome" class="inline"  />
                <img v-if="'image' in option" :src="option.image"                  class="inline w-4"  />
                {{ option.label }}
            </a>
        </div>
    </div>
</template>
<!-- TODO: Colors -->
<style scoped>

</style>

<script>
import { isEqual } from 'lodash'

export default {
    props: {
        options: Array,
        value: {
            // The v-model input
            type: [String,Number,Boolean,Array,Object,Date],
            required: false,
            default: undefined,
        },
        disabled: {
            type: Boolean,
            default: false,
        },
        color: {
            validator(value){
                return ['ug','red','green','purple','blue','green','yellow'].indexOf(value) !== -1;
            },
            required: true,
            default: 'teal',
        },
    },
    data(){
        let selectedId = -1;
        if(this.value !== undefined){
            for(let i = 0; i < this.options.length; i++){
                if(isEqual(this.value,this.options[i].value)){
                    selectedId = i;
                    break;
                }
            }
        }
        return {
            open: false,
            selectedId,
        }
    },
    computed: {
        selected(){
            return this.options[this.selectedId];
        },
    },
    methods: {
        openDropdown(){
            if(this.disabled === true) return;
            this.open = !this.open;
        },
        select(id){
            if(this.disabled) return;
            this.$emit('input',this.options[id].value);
        }, 
    },
    watch: {
        value(newVal){
            if(this.value !== undefined){
                for(let i = 0; i < this.options.length; i++){
                    if(isEqual(this.value,this.options[i].value)){
                        this.selectedId = i;
                        break;
                    }
                }
            }
        },
        disabled(newVal){
            if(newVal === true) this.open = false;
        },
    },

}
</script>